

using System;

namespace Espresso.OMR
{
  class BopDeform
    {
      public BopDeform()
	{}

      public Bitmap undeform(Bitmap src_bitmap, DeformData deform,
			     ComputingCircle circle)
	{
	  int y;

	  IntArray1d transform = deform.smooth_transform();
	  int y_deform = deform.y_deform();

	  int sx_dim = src_bitmap.x_dim();
	  int sy_dim = src_bitmap.y_dim();
	  int dx_dim = sx_dim;
	  int dy_dim = sy_dim + y_deform;

	  Bitmap dst_bitmap = new Bitmap(dx_dim,dy_dim);

	  // clear top bit where transform is not guaranteed to set
	  for (y=0; y<y_deform; y++)
	    for (int x=0; x<dx_dim; x++)
	      dst_bitmap.clear_pixel(x,y);

	  int area = sx_dim*sy_dim;
	  int mod_step = area/100;

	  int computed = 0;
	  int c=0;

	  for (y=0; y<sy_dim; y++)
	    for (int x=0; x<sx_dim; x++)
	      {
		if (((++c)%mod_step)==0) 
		  BaseIvLink.computed_so_far(circle,++computed);

		dst_bitmap[y+(y_deform-transform[x]),x]=src_bitmap[y,x];
	      }

	  BaseIvLink.computed_so_far(circle,100);

	  return dst_bitmap;
	}

    }
}      
