using System;
using System.IO;

namespace Espresso.OMR
{
	abstract class InputFileAccess
	{
		public enum Type { local, remote };

		protected InputFileAccess() {}
		~InputFileAccess() {}

		public static InputFileAccess Create(Type type)
		{
		  if (type == Type.local)
		    {
		      return new LocalFileAccess();
		    }
		  else 
		    {
		      return new RemoteFileAccess();
		    }
		}

		public abstract bool file_exists(string filename);
		
		public abstract BinaryReader open_file(string filename);
		public abstract void close_file();
	}
}

