
using System;

namespace Espresso.OMR
{
	class NewTemplate
	{
		// placeholder type for Dublin OCR package
	}

	class OcrFunction
	{
		public static bool ocr_check_bitmap_size(int x_dim, int y_dim)
		{
			Console.Error.WriteLine("Originally call to C code function");

			return true;
		}
		

		public static int ocr_get_no_score()
		{
			Console.Error.WriteLine("ocr_get_no_score: Not Implemented!");
			Console.Error.WriteLine("Originally call to C code function");

			return 0;
		}

		public static int ocr_get_accept_score()
		{
			Console.Error.WriteLine("Originally call to C code function");

			return 0;
		}

		public static void ocr_load_templates(string filename)
		{
			Console.Error.WriteLine("ocr_load_templates: Not Implemented!");
			Console.Error.WriteLine("Originally call to C code function");
		}


		public static void ocr_free_templates()
		{
			Console.Error.WriteLine("ocr_free_templates: Not Implemented!");
			Console.Error.WriteLine("Originally call to C code function");
		}


		public static void ocr_link_page(byte[,] page_data, int px_dim, int py_dim,
			short[] page_no_templates, 
			NewTemplate[,] page_templates)
		{
			Console.Error.WriteLine("ocr_link_page: Not Implemented!");
			Console.Error.WriteLine("Originally call to C code function");
		}


		public static void ocr_unlink_page()
		{
			Console.Error.WriteLine("ocr_unlink_page: Not Implemented!");
			Console.Error.WriteLine("Originally call to C code function");
		}

		public static void ocr_guess_char(int x_org, int y_org, int x_dim, int y_dim,
			out int score, out int tset, out int num)
		{
			Console.Error.WriteLine("ocr_guess_char: Not Implemented!");
			Console.Error.WriteLine("Originally call to C code function");
			score=0;
			tset=0;
			num=0;
		}

		


		public static string ocr_get_sn_name(int tset, int num)
		{
			Console.Error.WriteLine("ocr_get_sn_name: Not Implemented!");
			Console.Error.WriteLine("Originally call to C code function");

			return "";
		}

		public static byte[,] ocr_get_sn_library_graymap(int tset, int num)
		{
			Console.Error.WriteLine("ocr_get_sn_library_graymap: Not Implemented!");
			Console.Error.WriteLine("Originally call to C code function");

			return null;
		}

		public static int ocr_get_sn_lg_x_dim(int tset, int num)
		{
			Console.Error.WriteLine("ocr_sn_lg_x_dim: Not Implemented!");
			Console.Error.WriteLine("Originally call to C code function");

			return 0;
		}


		public static int ocr_get_sn_lg_y_dim(int tset, int num)
		{
			Console.Error.WriteLine("ocr_sn_lg_y_dim: Not Implemented!");
			Console.Error.WriteLine("Originally call to C code function");

			return 0;
		}


		public static short[] ocr_get_no_of_templates()
		{
			Console.Error.WriteLine("ocr_get_no_of_templates: Not Implemented!");
			Console.Error.WriteLine("Originally call to C code function");

			return null;
		}

		public static NewTemplate[,] ocr_get_templates()
		{
			Console.Error.WriteLine("ocr_get_no_of_templates: Not Implemented!");
			Console.Error.WriteLine("Originally call to C code function");

			return null;
		}
      

	}


	class OcrMatch
	{
		protected string name_;
		protected int score_;
		protected int tset_;
		protected int num_;
		protected byte[,] library_graymap_;
		protected int lg_x_dim_;
		protected int lg_y_dim_;


		public OcrMatch(string name, int score,
			int tset, int num,
			byte[,] library_graymap,
			int lg_x_dim, int lg_y_dim)
		{
			score_ = score;
			name_ = name;
			tset_ = tset;
			num_ = num;
			library_graymap_ = library_graymap;
			lg_x_dim_ = lg_x_dim;
			lg_y_dim_ = lg_y_dim;
		}

		public string name() { return name_; }
		public int score() { return score_; }
		public int set() { return tset_; }
		public int num() { return num_; }
		public byte[,] library_graymap() { return library_graymap_; }
		public int lg_x_dim() { return lg_x_dim_; }
		public int lg_y_dim() { return lg_y_dim_; }

	}

	/*-------------------------*/

	class OcrManager
	{
		

		protected string template_filename_;
		protected Bitmap page_bitmap_;
		protected NewTemplate[,] page_templates_;    // tset of templates
		protected short[] page_no_templates_; // no of templates in each template tset

		public OcrManager()
		{
			template_filename_ = "";
			page_bitmap_ = null; 
			page_no_templates_ = null;
			page_templates_ = null;

		}

		
		public OcrManager(string template_filename, Bitmap bitmap)
		{
			template_filename_ = template_filename;
			page_bitmap_ = bitmap;

			OcrFunction.ocr_load_templates(template_filename);
			page_no_templates_ = OcrFunction.ocr_get_no_of_templates();
			page_templates_ = OcrFunction.ocr_get_templates();
		}

		public void reload_templates(string template_filename)
		{
			if (template_filename_!="")
			{
				// free existing beta
				link_page();
				OcrFunction.ocr_free_templates();
			}

			template_filename_=template_filename;

			OcrFunction.ocr_load_templates(template_filename);
			page_no_templates_ = OcrFunction.ocr_get_no_of_templates();
			page_templates_ = OcrFunction.ocr_get_templates();
		}

		public void link_page()
		{
			// switch to local ocr template collection
			byte[,] page_data = page_bitmap_.data();
			int page_x_dim = page_bitmap_.x_dim();
			int page_y_dim = page_bitmap_.y_dim();

			OcrFunction.ocr_link_page(page_data,page_x_dim,page_y_dim,
				page_no_templates_, page_templates_);
		}

		public void unlink_page()
		{
			// switch back
			OcrFunction.ocr_unlink_page();
		}

		public OcrMatch match(int x_org, int y_org,
							  int x_dim, int y_dim)
		{
			int score,tset,num;
			OcrFunction.ocr_guess_char(x_org,y_org,x_dim,y_dim,out score,out tset,out num);

			string name;
			byte[,] library_graymap;
			int lg_x_dim, lg_y_dim;

			if (score<OcrFunction.ocr_get_no_score())
			{
				name = OcrFunction.ocr_get_sn_name(tset,num);
				library_graymap = OcrFunction.ocr_get_sn_library_graymap(tset,num);
				lg_x_dim = OcrFunction.ocr_get_sn_lg_x_dim(tset,num);
				lg_y_dim = OcrFunction.ocr_get_sn_lg_y_dim(tset,num);
			}
			else
			{
				name = "";
				library_graymap = null;
				lg_x_dim = 0;
				lg_y_dim = 0;
			}

			OcrMatch ocr_match
				= new OcrMatch(name,score,tset,num,library_graymap,lg_x_dim,lg_y_dim);

			return ocr_match;

		}


		public void new_page(Bitmap bitmap) { page_bitmap_ = bitmap; }

		public string template_filename() 
		{ return template_filename_; }


	}
}
