
using System;
using System.IO;

namespace Espresso.OMR
{

  class StaffLines
    {

      protected SubBitmapArray1d bitmaps_;

      public StaffLines()
	{
	  bitmaps_ = new SubBitmapArray1d();
	}

      public void resize(int no_lines) { bitmaps_.resize(no_lines); }
      public SubBitmapArray1d bitmaps() { return bitmaps_; }



      /*---------------------------------------------------------------------------*/

      public void write_staff_lines(BinaryWriter brout, int y_offset)
	{
	  SubBitmapArray1d line_bitmaps = bitmaps_;

	  int no_lines = line_bitmaps.length();
	  IOSupport.write_line(brout,"no_lines = " + no_lines);

	  for (int i=0; i<no_lines; i++)
	    {
	      line_bitmaps[i].add_to_y_org(-y_offset);
	      line_bitmaps[i].write(brout);
	      line_bitmaps[i].add_to_y_org(+y_offset);
	    }
	}

      /*
      ostream& operator << (BinaryWriter brout, StaffLines& lines)
	{
	  lines.write_staff_lines(os);
	  return os;
	}
      */


      public bool read_staff_lines(BinaryReader brin, int y_offset)
	{
	  // staff assumed to be empty

	  int no_lines;
	  if (!IOSupport.read_token(brin,"no_lines")) return false;
	  if (!IOSupport.read_token(brin,"=")) return false;
	  if (!IOSupport.read_cardinal(brin,out no_lines)) return false;

	  SubBitmapArray1d line_bitmaps = bitmaps_;
	  line_bitmaps.resize(no_lines);

	  for (int i=0; i<no_lines; i++)
	    {
	      if (!line_bitmaps[i].read(brin)) return false;
	      line_bitmaps[i].add_to_y_org(y_offset);
	    }

	  return true;
	}

      /*
      istream& operator >> (BinaryReader brin, StaffLines& lines)
	{
	  (void)lines.read_staff_lines(is);
	  return is;  
	}
      */




    }
}




