

using System;

namespace Espresso.OMR
{
	class CpuUsage
	{

		object startTimeRef_;
		object endTimeRef_;

		public CpuUsage()
		{
			clear_timer();
		}

		public void clear_timer()
		{
			startTimeRef_ = null;
			endTimeRef_ = null;
		}

		public void start_timer()
		{
			startTimeRef_ = HighResClock.Now; // boxed
		}


		public int snapshot_timer()
		{
			// return time rounded to closest milliseconds

			DateTime endTime = HighResClock.Now;
			DateTime startTime = (DateTime)startTimeRef_; // unboxed

			TimeSpan duration = HighResClock.CalcTimeSpan(startTime,endTime);

			return MathExtra.irint(duration.TotalMilliseconds);
		}

		public int stop_timer()
		{
			// return time rounded to closest milliseconds

			if (endTimeRef_ == null) 
			{
				endTimeRef_ = HighResClock.Now; // boxed
			}
			else 
			{
				Console.Error.WriteLine("Timer has already been stopped!");
			}

			DateTime startTime = (DateTime)startTimeRef_; // unboxed
			DateTime endTime = (DateTime)endTimeRef_; // unboxed

			TimeSpan duration = HighResClock.CalcTimeSpan(startTime,endTime);

			return MathExtra.irint(duration.TotalMilliseconds);
		}
	}
}

	
	

      
