
using System;

namespace Espresso.OMR
{
  class PointStack
    {
      int limit_;
      int top_;
      PointArray1d pt_;


      public PointStack(int size)
	{
	  pt_ = new PointArray1d(size);
	  limit_ = size;
	  top_ = 0;
	}

      public bool is_empty() { return top_==0; }
      
      public void reset(int size)
	{
	  pt_.resize(size);
	  limit_ = size;
	  top_ = 0;
	}

      public Point pop()
	{
	  return pt_[--top_];
	}

      public void push(Point pt)
	{
	  if (top_==limit_)
	    {
	      // double size of stack 
	      limit_*=2;
	      pt_.extend(limit_);
	    }
	  
	  pt_[top_++]=pt; // think about making deep copy here *******
	}

      // non standard

      /*
      public void push(int x, int y)
	{
	  if (top_==limit_)
	    {
	      // double size of stack 
	      limit_*=2;
	      pt_.extend(limit_);
	    }
	  
	  pt_[top_].x(x);
	  pt_[top_].y(y);
	  top_++;
	}
      */

    }

}
      


