
using System;

namespace Espresso.OMR
{
  class StringArray1d
    {
      protected String[] array_;
      protected int len_;

      private int print_width_;

      public StringArray1d()
	{ 
	  array_ = null; 
	  len_ = 0; 
	  print_width_=0;
	}

      public StringArray1d(int len) 
	{ 
	  len_ = len; 
	  print_width_=0;

	  if (len>0) 
	    {
	      array_ = new String[len];
	      if (GetType().IsClass) 
		{
		  for (int i=0; i<len; i++)
		    {
		      array_[i] = "";
		    }
		} 

	    }
	  else 
	    { 
	      array_ = null;
	    }
	}

      public void resize(int len)
	{ 
	  array_ = new String[len]; 
	  if (GetType().IsClass) 
	    {
	      for (int i=0; i<len; i++)
		{
		      array_[i] = "";
		}
	    } 

	  len_ = len; 
	  print_width_=0;
	}

      public void extend(int len)
	{ 
	  String[] new_array = new String[len]; 
	  for (int i=0; i<len_; i++)  {

	    // OK to share reference, as the purpose of this is to *move* the
	    // the items currently in array_ over to new_array.  array_
	    // then becomes overriden by value of new_array

	    new_array[i]=array_[i]; 
          }

	  for (int ii=len_; ii<len; ii++)
	    {
	      new_array[ii] = "";
	    }

	  len_ = len; 

	  array_=new_array;
	}


      public void print()
	{ 
	  for (int i=0; i<len_; i++)
	    Console.Out.WriteLine(i.ToString() + ": " + array_[i].ToString());
	}	

      /*

      ostream& operator << (ostream& os, const StringArray1d& array)
	{ 
	  os << "[";
	  for (int i=0; i<array.len_; i++)
	    {
	      os.width(array.print_width_);
	      os << array.array_[i] << " ";
	    }
	  os << "]";
	  return os;
	}
      */


      public int length()
	{ 
	  return len_;
	}


      public void print_width(int w)
	{ 
	  print_width_=w;
	}

      public StringArray1d ShallowCopy()
	{
	  StringArray1d array_copy = new StringArray1d(len_);
	  for (int i=0; i<len_; i++) {
	    array_copy[i] = array_[i];
	  }

	  return array_copy;
	}


      public String this [int index]
 	{
  	  get
  	  {
	    return array_[index];
  	  }
  	  set
  	  {
   	    array_[index] = value;
  	  }
 	}

      public String[] data() { return array_; }
	
      public void down_size(int len) 
      { 
	// safe (and fast), but perhaps not the most efficient use of memory
	len_ = len; 

      } 
    }
}
      
