using System;
using System.IO;

namespace Espresso.OMR
{
	class Point
	{
		public delegate void IncrementDelegate(int incr);

		protected int x_;
		protected int y_;
      
		public Point()
		{}
      
		public Point(int x, int y)
		{
			x_ = x;
			y_ = y;
		}
      
		public Point DeepCopy()
		{
			Point pt_copy = new Point(x_,y_);

			return pt_copy;
		}

		public static bool operator ==(Point pt_lhs, Point pt_rhs)
		{ 
			return (pt_lhs.x_==pt_rhs.x_) && (pt_lhs.y_==pt_rhs.y_); 
		}
      
		public static bool operator!=(Point point_lhs, Point point_rhs)
		{
			return !(point_lhs == point_rhs);
		}

      
		public override bool Equals(object obj)
		{
			if (!(obj is Point))
			{
				return false;
			}
			return this == (Point) obj;
		}

		public override int GetHashCode() 
		{
			// not a particulary smart hashing function.  Is hashing used, this should be replaced
			return x_ + y_; 
		}


		public void x(int x) 
		{ 
			x_ = x; 
		}
		public void y(int y) 
		{ 
			y_ = y;
		}
      
		public int x() { return x_; } 
		public int y() { return y_; } 
      
		public void x_incr(int incr) { x_ += incr; }
		public void y_incr(int incr) { y_ += incr; }


		public void write(StreamWriter sw)
		  {
		    sw.Write("(" + x_.ToString() + "," + y_.ToString() + ")");
		  }

		
	}

}

