
using System;
using System.IO;

namespace Espresso.OMR
{
	class ShareGlobals
	{
		public static String ocr_template_filename_ = "default.tpl";
		public static int    ocr_accept_match_add_=500; // controls threshold for match
		public static int    scan_dpi_ = 300;
		public static int    order_xy_gap_tol_ = 4;

		public static void reset()
		{
			ocr_template_filename_ = "default.tpl";
			ocr_accept_match_add_=500; // controls threshold for match
			scan_dpi_ = 300;
			order_xy_gap_tol_ = 4;
		}

      
		protected static void initialise_variable(string buffer)
		{
			// pick out variable name (buffer in the form var = value)
  
			int equals_pos = buffer.IndexOf('=');
			string var_name = buffer.Substring(0,equals_pos);

			var_name = var_name.Trim();

			string var_value = buffer.Substring(equals_pos+1);
			var_value = var_value.Trim();

			int attempt_int;
      
			if (var_name=="ocr_template_filename")
			{		  
				string setenv = "OCR_TPLATES_FILENAME="+var_value;
				// Environment.SetEnvironmentVariable(setenv); // what is C# equiv of this? // ****
				ocr_template_filename_ = var_value;
			}
			else if (var_name=="ocr_accept_match_add")
			{
				attempt_int = Int32.Parse(var_value);
				ocr_accept_match_add_ = attempt_int;
			}
			else if (var_name=="scan_dpi")
			{
				attempt_int = Int32.Parse(var_value);
				scan_dpi_ = attempt_int;
			}
			else if (var_name=="order_xy_gap_tol")
			{
				// warning: this will not be set if using DPrimGlobals since
				// this variable name is over-shadowed by the same name there
				attempt_int = Int32.Parse(var_value);
				order_xy_gap_tol_ = attempt_int;
			}
		}
  


		public static void source_file(BinaryReader brin)
		{
			int line_no = 1;

			while (brin.PeekChar() != -1)
			{
				// read in line  
				bool ignore = false;
				
				string buffer;
				IOSupport.read_line(brin,out buffer);
				int line_len = buffer.Length;

				// check if comment
				if (line_len>=2)
				{
					if ((buffer[0]=='/') && (buffer[1]=='/')) ignore=true;
				}

				if (!ignore) initialise_variable(buffer);

				line_no++;
			}  
		}
	}
}
      
