
using System;
using System.Collections;

namespace Espresso.OMR
{

  class Statistics
  {
/*
	  public delegate bool LessThanDelegate(object x, object y);
	  public delegate bool GreaterThanDelegate(object x, object y);
*/

	  public delegate int IntValDelegate(object v);
	  public delegate double DoubleValDelegate(object v);

/*
	  public static bool int_less_than(object x, object y)
	  {
		  int int_x = (int)x;
		  int int_y = (int)y;

		  return (int_x < int_y);
	  }

	  public static bool int_greater_than(object x, object y)
	  {
		  int int_x = (int)x;
		  int int_y = (int)y;

		  return (int_x > int_y);
	  }
*/

	 
	  public static object min_value(Array array)
	  {	
		  if (array==null) return 0;

		  IComparable min_val = (IComparable)array.GetValue(0);
		  
		  for (int i=0; i<array.Length; i++)
		  {
			  IComparable val = (IComparable)array.GetValue(i);

			  if (val.CompareTo(min_val)<0)
			  {
				  min_val = val;
			  }
		  }

		  return min_val;
	  }


	  public static object max_value(Array array)
	  {
		  if (array==null) return 0;

		  IComparable max_val = (IComparable)array.GetValue(0);

		  for (int i=0; i<array.Length; i++)
		  {
			  IComparable val = (IComparable)array.GetValue(i);

			  if (val.CompareTo(max_val)>0)
			  {
				  max_val = val;
			  }
		  }

		  return max_val;
	  }


	  public static int int_range(Array array, IntValDelegate extract_int)
	  {
		  if (array==null) return 0;

		  int min_val,max_val;
		  min_val = max_val = extract_int(array.GetValue(0));

		  for (int i=0; i<array.Length; i++)
		  {
			  int val = extract_int(array.GetValue(i));

			  if (val<min_val) min_val = val;
			  if (val>max_val) max_val = val;
		  }

		  return (max_val - min_val) + 1;
	  }

   
	  public static double int_mean(Array array, IntValDelegate extract_int)
	  {
		  if (array==null) return 0.0;

		  int total=0;

		  for (int i=0; i<array.Length; i++)
			  total+=extract_int(array.GetValue(i));

		  return (double)total/(double)array.Length;
	  }

	  public static double double_mean(Array array, DoubleValDelegate extract_double)
	  {
		  if (array==null) return 0.0;

		  double total=0.0;

		  for (int i=0; i<array.Length; i++)
			  total+=extract_double(array.GetValue(i));

		  return total/(double)array.Length;
	  }


  
	  public static double int_mode(Array array, IntValDelegate extract_int)
	  {
		  int i;

		  if (array==null) return 0.0;

		  int min_val = (int)min_value(array);
		  int max_val = (int)max_value(array);
		  int range = max_val - min_val +1;

		  IntArray1d freq = new IntArray1d(range);
		  for (i=0; i<range; i++)
			  freq[i]=0;

		  for (i=0; i<array.Length; i++)
		  {
			  int val = extract_int(array.GetValue(i));
			  freq[val-min_val]++;
		  }

		  int max_freq_val = freq[0];

		  for (i=1; i<range; i++)
		  {
			  int val = freq[i];
			  if (val>max_freq_val) max_freq_val=val;
		  }

		  // track in from left
		  i=0;
		  while (freq[i]<max_freq_val) i++;
		  int left_most_max_freq_pos = i;

		  // track in from right
		  i=range-1;
		  while (freq[i]<max_freq_val) i--;
		  int right_most_max_freq_pos = i;

		  double max_freq_pos_avg 
			  = (double)(left_most_max_freq_pos + right_most_max_freq_pos)/2.0;
		  return (double)min_val + max_freq_pos_avg;
	  }

  
	  public static double int_median(Array array, IntValDelegate extract_int)
	  {
		  if (array==null) return 0.0;

		  IntArray1d key = new IntArray1d(array.Length);

		  for (int i=0; i<array.Length; i++)
			  key[i]=extract_int(array.GetValue(i)); 

		  Array.Sort(key.data());
  
		  double middle_value;
		  if (array.Length%2==0)
		  {
			  middle_value =(double)(key[(array.Length-1)/2]+key[array.Length/2])/2.0;
		  }
		  else 
		  {
			  middle_value = (double)key[array.Length/2];
		  }

		  return middle_value;
	  }

	  

	  public static double int_variance(Array array, IntValDelegate extract_int)
	  {
		  if (array==null) return 0.0;

		  if (array.Length==1) return 0.0;
		  double avg = int_mean(array,extract_int);

		  double total = 0.0;

		  for (int i=0; i<array.Length; i++)
		  {
			  int val = extract_int(array.GetValue(i));

			  total+=MathExtra.sqr((double)val-avg);
		  }

		  return total/(double)(array.Length-1);
	  }

	  public static double int_standard_deviation(Array array, IntValDelegate extract_int)
	  {
		  return Math.Sqrt(int_variance(array,extract_int));
	  }



	  public static int get_int(object this_entry)
	  {
		  int data = (int)this_entry; // unboxed
		  return data; // provide selector function for integer arrays
	  }

	  public static double get_double(object this_entry)
	  {
		  double data = (double)this_entry; // unboxed
		  return data; // provide selector function for double arrays
	  }

	  public static int get_staff_region_thickness(object this_entry)
	  {
		  // provide selection function for staff region arrays

		  StaffRegion data = (StaffRegion)this_entry;
		  return data.thickness();
	  }

   /*

    int statistics_staff_region_thickness(void* this_entry)
      {
	// provide selection function for staff region arrays

	StaffRegion* data = (StaffRegion*)this_entry;
	return data->thickness(); 
      }
	  
*/

  }
  
}
