
using System;
using System.IO;

namespace Espresso.OMR
{
	class VSpan
	{
		protected int yt_;
		protected int yb_;
		protected int x_;


		public VSpan()
		{}
      
		public VSpan(int x, int yt, int yb)
		{
			yt_ = yt;
			yb_ = yb;
			x_ = x;
		}

		/*
		public VSpan& operator =(VSpan& vspan)
		{ yt_ = vspan.yt_; yb_ = vspan.yb_; x_ = vspan.x_; return vspan; }
		*/

		public VSpan DeepCopy()
		{
			VSpan vspan_copy = new VSpan(x_,yt_,yb_);

			return vspan_copy;
		}

		public static bool operator ==(VSpan vspan_lhs, VSpan vspan_rhs)
		{ return (vspan_lhs.yt_==vspan_rhs.yt_) && (vspan_lhs.yb_==vspan_rhs.yb_) && (vspan_lhs.x_==vspan_rhs.x_); }

		public static bool operator !=(VSpan vspan_lhs, VSpan vspan_rhs)
		{ return (vspan_lhs.yt_!=vspan_rhs.yt_) || (vspan_lhs.yb_!=vspan_rhs.yb_) || (vspan_lhs.x_!=vspan_rhs.x_); }


		public override bool Equals(object obj)
		{
			if (!(obj is VSpan))
			{
				return false;
			}
			return this == (VSpan) obj;
		}
      
		public override int GetHashCode() 
		{
			// not a particulary smart hashing function.  If hashing used, this should be replaced
			return x_ + yt_ + yb_; 
		}
      

		public void yt(int yt) { yt_ = yt; }
		public void yb(int yb) { yb_ = yb; }
		public void x(int x) { x_ = x; }

		public int yt() { return yt_; }
		public int yb() { return yb_; }
		public int x() { return x_; }


		public void write(StreamWriter sw)
		  {
		    sw.Write("(" + x_.ToString() + ": " + yt_ + "," + yb_ + ")");
		  }
	}
}
