using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Espresso.Utils.View
{
    public partial class OpenRequestForm : Form
    {
        /// <summary>
        /// Asks the user if they actually want to open the whole document or just certain pages
        /// </summary>
        /// <param name="firstPage">Number of the first page user wants to open</param>
        /// <param name="lastPage">Last page user wants to open</param>
        public static void AskForOpenConfirmation(out int firstPage,
                                                  out int lastPage,
                                                  int numberOfPages)
        {
            firstPage = 1;
            lastPage = numberOfPages;

            OpenRequestForm form = new OpenRequestForm();
            form.tx_Last.Text = "" + numberOfPages;

            DialogResult result = form.ShowDialog();

            if (result == DialogResult.OK)
            {//Opening a range of pages
                firstPage = Convert.ToInt32(form.tx_First.Text);
                lastPage = Convert.ToInt32(form.tx_Last.Text);
            }
            else if (result == DialogResult.Ignore)
            {
                firstPage = 1;
                lastPage = numberOfPages;
            }
            else
            {//Cancelled
                firstPage = -1;
            }
        }

        public OpenRequestForm()
        {
            InitializeComponent();
        }

        private void button2_Click(object sender, EventArgs e)
        {

        }
    }
}