using System;
using System.Collections.Generic;
using System.Text;

namespace Espresso.Utils
{
    /// <summary>
    /// A simple logger class that could later be replaced with log4net
    /// </summary>
    public class Logger
    {
        public static int verboseLevel = 2;

        /// <summary>
        /// Prints the message to stdout
        /// </summary>
        /// <param name="message"></param>
        public static void Info(string message)
        {
            System.Console.WriteLine(message);
        }

        /// <summary>
        /// Formats the string and prints to stdout.
        /// </summary>
        /// <param name="message"></param>
        /// <param name="formatObjects"></param>
        public static void Info(string message, params object[] formatObjects)
        {
            System.Console.WriteLine(string.Format(message, formatObjects));
        }

        /// <summary>
        /// Writes the message to stderr
        /// </summary>
        /// <param name="message"></param>
        public static void Error(string message)
        {
            System.Console.Error.WriteLine(message);
        }

    }
}
