using System;
using System.Collections.Generic;
using System.Text;

namespace Espresso.Viewer.Commands
{
    public interface ICommand
    {
        /// <summary>
        /// Executes the command
        /// </summary>
        void Execute(object[] parameters);
        
        /// <summary>
        /// The state of the command.
        /// </summary>
        CommandState State
        {
            get;
            set;
        }
    }

    public enum CommandState
    {
        Available,
        Disabled,
        Hidden
    }
}
