﻿using System;
using System.Collections.Generic;
using System.Text;
using Espresso.Viewer.Model;
using Espresso.Viewer.View;

namespace Espresso.Viewer.Controller
{
    public class DocumentViewerController
    {
        //private DocumentFragmentsViewerController m_docFragmentsController;

        private Document m_document;
        public Document Document {
            get { return m_document; }
            set { m_document = value; }
        }

        private List<DocumentFragment> m_documentFragments;
        public List<DocumentFragment> DocumentFragments {
            get { return m_documentFragments; }
            set { m_documentFragments = value; }
        }

        //private EspressoViewer m_viewer;
        
        private int m_numPagesToBeDisplayed;
        public int NumPagesToBeDisplayed
        {
            get
            {
                return m_numPagesToBeDisplayed;
            }
            set
            {
                m_numPagesToBeDisplayed = value;
            }
        }

        public DocumentViewerController(Document document, int numPagesToBeDisplayed)
        {
            this.Document = document;
            // this.m_viewer = viewer;
            this.NumPagesToBeDisplayed = numPagesToBeDisplayed;
            
            divideDocumentIntoFragments();
            //this.m_docFragmentController = new DocumentFragmentViewerController(this.Document, this.DocumentFragments[0], viewer);
        }

        private void divideDocumentIntoFragments() 
        {
            int totalNumPages = this.Document.Pages.Count;
            float result = (float) totalNumPages / (float) NumPagesToBeDisplayed;
            int numPagesPerDocumentFragment = (int)Math.Ceiling(result); // overestimating for safety.
            this.DocumentFragments = new List<DocumentFragment>(NumPagesToBeDisplayed);

            // fill DocumentFragments (list) with fragments
            for (int i = 0; i < NumPagesToBeDisplayed; i++)
            {
                this.DocumentFragments.Add(new DocumentFragment());
            }

            // fill each Fragment with pages

            for (int i = 0; i < totalNumPages; i++)
            {
                Page aPage = this.Document.Pages[i];
                this.DocumentFragments[i % NumPagesToBeDisplayed].addPage(aPage);
            }
        }
    }
}
