using System;
using System.Collections.Generic;
using System.Text;

namespace Espresso.Viewer.Controller
{
    /// <summary>
    /// A mouse strategy that goes back one page on double click
    /// </summary>
    public class DoubleClickBackMouseStrategy : MouseStrategy
    {
        /// <summary>
        /// Makes transition to the next page
        /// </summary>
        public override void LeftClick()
        {
            m_Controller.GoToNextPage(true);
        }

        /// <summary>
        /// Instantly goes to previous page
        /// </summary>
        public override void RightClick()
        {
            m_Controller.GoToPreviousPage(false);
        }

        /// <summary>
        /// Makes transition to previous page
        /// </summary>
        public override void DoubleClick()
        {
            m_Controller.GoToPreviousPage(true);
        }

        public DoubleClickBackMouseStrategy(IViewerController controller) : base(controller) { }
    }
}
