﻿using System;
using Espresso.Viewer.Model;
using Espresso.Viewer.View;

namespace Espresso.Viewer.Controller
{
    public interface IViewerController : IFieldContainer<IPainter>,
                                         IFieldContainer<MouseStrategy>
    {
        void GoToFirstPage(bool doTransition);
        void GoToLastPage(bool doTransition);
        void GoToNextPage(bool doTransition);
        void GoToPage(int n, bool doTransition);
        void GoToPreviousPage(bool doTransition);
        void ChooseNextMenuItem();
        void SelectMenuItem();
        void ToggleMenu();
        void Reset();

        Timer Timer { get;}
        Menu Menu { get;}
    }
}
