using System;
using System.Collections.Generic;
using System.Text;

namespace Espresso.Viewer.Controller
{
    /// <summary>
    /// Defines the interface for the mouse starategy
    /// </summary>
    public abstract class MouseStrategy
    {
        public abstract void LeftClick();

        public abstract void RightClick();

        public abstract void DoubleClick();

        protected IViewerController m_Controller;

        /// <summary>
        /// A default constructor.
        /// </summary>
        /// <param name="controller">The controller that this mouse strategy controls</param>
        public MouseStrategy(IViewerController controller)
        {
            m_Controller = controller;
        }
    }
}
