using System;
using System.Collections.Generic;
using System.Text;

namespace Espresso.Viewer.Controller
{
    public class MouseStrategyBuilder : IBuilder<MouseStrategy>
    {
        private IViewerController controller;

        public MouseStrategyBuilder(IViewerController controller)
        {
            this.controller = controller;
        }

        public MouseStrategy Build(string description)
        {
            MouseStrategy retVal = null;

            if (description.Equals("LeftNextRightPrevious"))
            {
                retVal = new RightClickBackMouseStrategy(controller);
            }
            else if (description.Equals("MenuChoice"))
            {
                retVal = new MenuToggleMouseStrategy(controller);
            }
            else if (description.Equals("SingleNextDoublePrevious"))
            {
                retVal = new DoubleClickBackMouseStrategy(controller);
            }

            return retVal;
        }
    }
}
