using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace Espresso.Viewer.Controller
{
    /// <summary>
    /// Only throws click and right click events.
    /// </summary>
    public class SimpleMouseHandler : EspressoMouseHandler
    {
        public override event MouseDelegate Click;
        public override event MouseDelegate DoubleClick;
        public override event MouseDelegate RightClick;

        public override void ProcessClick(object sender, EventArgs e)
        {
            MouseEventArgs args = null;

            try
            {
                args = e as MouseEventArgs;
            }
            catch
            {
                return;
            }

            if (args.Button == MouseButtons.Left)
            {
                if (Click != null)
                {
                    Click();
                }
            }
            else
            {
                if (RightClick != null)
                {
                    RightClick();
                }
            }
        }
    }
}
