using System;
using System.Xml;
using System.Xml.Serialization;

namespace Espresso.Viewer.Model
{
    /// <summary>
    /// A class representing a point in 2D space
    /// </summary>
    [XmlRoot("point")]
    public class EspressoPoint
    {
        private int m_X;

        /// <summary>
        /// X coordinate of the point
        /// </summary>
        [XmlElement("x")]
        public int X
        {
            get { return m_X; }
            set { m_X = value; }
        }

        private int m_Y;

        /// <summary>
        /// Y coordinate of the point
        /// </summary>
        [XmlElement("y")]
        public int Y
        {
            get { return m_Y; }
            set { m_Y = value; }
        }

        /// <summary>
        /// Creates a point at (x, y)
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        public EspressoPoint(int x, int y)
        {
            this.X = x;
            this.Y = y;
        }

        /// <summary>
        /// Creates a point at (0,0)
        /// </summary>
        public EspressoPoint() : this(0, 0) { }
    }
}
