using System;
using System.Collections.Generic;
using System.Text;

namespace Espresso.Viewer.Model
{
    public class TimeSignature
    {
        private int m_BeatsPerMeasure;

        public int BeatsPerMeasure
        {
            get { return m_BeatsPerMeasure; }
            set { m_BeatsPerMeasure = value; }
        }

        private int m_NoteType;

        public int NoteType
        {
            get { return m_NoteType; }
            set { m_NoteType = value; }
        }

        private int m_NotesPerMinute;

        public int NotesPerMinute
        {
            get { return m_NotesPerMinute; }
            set { m_NotesPerMinute = value; }
        }

        public float BarsPerMinute
        {
            get
            {
                if (BeatsPerMeasure == 0 || NoteType == 0)
                    return 0;

                float note = BeatsPerMeasure / NoteType;
                return (float)(NotesPerMinute * note);
            }
        }

        public float SecondsPerBar
        {
            get
            {
                return 60 / BarsPerMinute;
            }
        }

        public TimeSignature(int bpm, int type)
        {
            BeatsPerMeasure = bpm;
            NoteType = type;
        }	
    }
}
