using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using Espresso.Viewer.Model;

namespace Espresso.Viewer.View
{
    public class MenuPainter : PainterDecorator
    {
        //TODO: Get rid of this!!! View layer should not know about Menus
        private Menu m_Menu;

        public Menu Menu
        {
            get { return m_Menu; }
            set { m_Menu = value; }
        }

        public MenuPainter(AbstractPainter decoratee, Menu menu)
            : base(decoratee)
        {
            Menu = menu;
        }

        public override void Paint(object sender, System.Windows.Forms.PaintEventArgs args)
        {
            decoratee.Paint(sender, args);

            Graphics g = args.Graphics;
            Point origin = new Point(10, 100);
            int height = 25;
            int width = 150;
            int i = 0;

            if (!Menu.IsVisible)
                return;

            foreach (MenuItem item in Menu.Items)
            {
                origin.Y = 100 + height * i;
                
                if (item == Menu.CurrentItem)
                    g.FillRectangle(new SolidBrush(Color.FromArgb(127, Color.Gray)), origin.X, origin.Y, width, height);
                else
                    g.FillRectangle(new SolidBrush(Color.FromArgb(127, Color.LightGray)), origin.X, origin.Y, width, height);
                
                Font f = new Font("Helvetica", 14, FontStyle.Bold, GraphicsUnit.Pixel);
                
                g.DrawString(item.Text, f, Brushes.Black, new PointF(origin.X + 5, origin.Y + 5));
                i++;
            }
            
        }

        public override string Name
        {
            get { return "MenuPainter"; }
        }
    }
}
