using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace Espresso.Viewer.View
{
    public abstract class PainterDecorator : AbstractPainter
    {
        protected AbstractPainter decoratee;

        public PainterDecorator(AbstractPainter decoratee)
        {
            this.decoratee = decoratee;
        }

        public override void Paint(object sender, PaintEventArgs args)
        {
            decoratee.Paint(sender, args);
        }

        public override System.Drawing.Bitmap NewImage
        {
            get
            {
                return decoratee.NewImage;
            }
            set
            {
                decoratee.NewImage = value;
            }
        }

        public override System.Drawing.Bitmap OldImage
        {
            get
            {
                return decoratee.OldImage;
            }
            set
            {
                decoratee.OldImage = value;
            }
        }

        public override float CompleteRatio
        {
            get
            {
                return decoratee.CompleteRatio;
            }
            set
            {
                decoratee.CompleteRatio = value;
            }
        }

        public override string Name
        {
            get
            {
                return "Decorator";
            }
        }
    }
}
