using System;
using System.Collections.Generic;
using System.Text;

namespace Espresso
{
    /// <summary>
    /// Interface for object used to build objects of type T based on a string description of the object
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public interface IBuilder<T>
    {
        /// <summary>
        /// Builds an object of type T based on a given description
        /// </summary>
        /// <param name="description"></param>
        /// <returns></returns>
        T Build(string description);
    }
}
