using System;
using System.Collections.Generic;
using System.Text;

namespace Espresso
{
    /// <summary>
    /// Interface for classes that are used by <see cref="FieldUpdater"/>. Inheritors must contain only
    /// one method -- the setter for the field
    /// </summary>
    /// <typeparam name="T">Type of the field that is being updated</typeparam>
    public interface IFieldContainer<T>
    {
        /// <summary>
        /// A setter for a field of type T
        /// </summary>
        /// <param name="newValue"></param>
        void SetField(T newValue);
    }
}
